#include <iostream>
using std::cout;
using std::cin;

//#include <cmath>
//#include <complex>

#include "transform.h"

const int Val = 8;
const int fr = 7;

int main()
{

	try {
		WFastHT< double, double > haaras( Val );
		WIFastHT< double, double > ihaaras( Val );
		double data[Val] = { 1,2,3,4,4,3,2,1 };
		double *pD, *pS;
		
		haaras.setData( data );
		haaras.doTransform();
		pD = haaras.getSpectrum();
		
		cout << "Input signal: \n";
		for( int i = 0; i < Val; i++ ) {
			cout << data[ i ] << "\n";
		}

		cout << "\nSpectrum: \n";
		for( i = 0; i < Val; i++ ) {
			cout << pD[ i ] << "\n";
		}
		
		ihaaras.setData( pD );
		ihaaras.doTransform();
		pS = ihaaras.getSpectrum();

		cout << "\nInverse haara's transformation: \n";
		for( i = 0; i < Val; i++ ) {
			cout << pS[ i ] << "\n";
		}
	}
	catch( TransError::badNValue ) {
		cout << "Bad N!\n";
	}
	catch( TransError::noData ) {
		cout << "No data avaible!\n";
	}
	catch( TransError::noSuchBasis ) {

	}
	return 1;
}